<?php

class Paczkomaty247API extends Module
{
	
	public static function machine_distance_sort($m1, $m2)
	{
		if ($m1['distance'] == $m2['distance']) return 0;
  		return ($m1['distance'] < $m2['distance']) ? -1 : 1;
	}

	public function find_nearest_machines($postcode, $config)
	{
		if ($machinesContents = @file_get_contents("$config->apiURL/?do=findnearestmachines&postcode=$postcode")) {
			$parsedXML = $this->xml2array($machinesContents);
			
			if (!isset($parsedXML['paczkomaty']['machine'])) return 0;   
    			$machines = $parsedXML['paczkomaty']['machine'];		
			
			if (count($machines)) {
				$allMachines = $this->get_machine_list($config);
      				$i=0;
      				foreach($allMachines as $machineDetails) {
        				foreach($machines as $machine) {
          					if ($machine['name']['value']==$machineDetails['name']) {
            						$machineList[$i] = $machineDetails;
            						$machineList[$i]['distance'] = $machine['distance']['value'];
            						$i++;
         					 }
       					 }
      				}
      				usort($machineList, array('Paczkomaty247API', 'machine_distance_sort'));
      				return $machineList;   	
			}
		}
		return 0;
	}	

	public function xml2array($contents, $get_attributes=1)
	{

		if(!$contents) return array();
		if(!function_exists('xml_parser_create')) {
			return array();
		}
		$parser = xml_parser_create();
		xml_parser_set_option( $parser, XML_OPTION_CASE_FOLDING, 0 );
		xml_parser_set_option( $parser, XML_OPTION_SKIP_WHITE, 1 );
		xml_parse_into_struct( $parser, $contents, $xml_values );
		xml_parser_free( $parser );

		if(!$xml_values) return;

		$xml_array = array();
		$parents = array();
		$opened_tags = array();
		$arr = array();
		$current = &$xml_array;

		foreach($xml_values as $data) {
			unset($attributes,$value);
			extract($data);
			$result = '';
			if($get_attributes) {
				$result = array();
				if(isset($value)) $result['value'] = $value;
				if(isset($attributes)) {
					foreach($attributes as $attr => $val) {
						if($get_attributes == 1) $result['attr'][$attr] = $val;
					}
				}
			} elseif(isset($value)) {
				$result = $value;
			}

			if($type == 'open') {
				$parent[$level-1] = &$current;
				if(!is_array($current) or (!in_array($tag, array_keys($current)))) {
					$current[$tag] = $result;
					$current = &$current[$tag];
				} else {
					if(isset($current[$tag][0])) {
						array_push($current[$tag], $result);
					} else {
						$current[$tag] = array($current[$tag],$result);
					}
					$last = count($current[$tag]) - 1;
					$current = &$current[$tag][$last];
				}
			} elseif($type == 'complete') {
				if(!isset($current[$tag])) {
					$current[$tag] = $result;
				} else {
					if((is_array($current[$tag]) and $get_attributes == 0)
					or (isset($current[$tag][0]) and is_array($current[$tag][0]) and $get_attributes == 1)) {
						array_push($current[$tag],$result);
					} else {
						$current[$tag] = array($current[$tag],$result);
					}
				}
			} elseif($type == 'close') {
				$current = &$parent[$level-1];
			}
		}
		return($xml_array);
	}

	public function get_machine_list($config, $town='') {
  
	  if ($this->cache_is_valid(1, $config)==0) {
	    $this->download_machines($config);
	  }
	  if ($cache = @file_get_contents(dirname(__FILE__) . "/data/cache1.dat")) {
	    $machineList = unserialize($cache);
	    if (count($machineList)) {
	      if ($town) {
	        foreach ($machineList as $machine) {
	          if ($machine[4]==$town) $resultList[] = $machine;
	        }
	        $machineList = $resultList;  
	      }
	      if (count($machineList)) {
	        $resultList = array();
	        $i=0;
	        foreach($machineList as $machine) {
	          $resultList[$i]['name'] = $machine[0];
	          $resultList[$i]['street'] = $machine[1];
	          $resultList[$i]['buildingnumber'] = $machine[2];
	          $resultList[$i]['postcode'] = $machine[3];
	          $resultList[$i]['town'] = $machine[4];
	          $resultList[$i]['latitude'] = $machine[5];
	          $resultList[$i]['longitude'] = $machine[6];
	          if ($machine[7]=='t') $resultList[$i]['paymentavailable'] = 1;
	          else $resultList[$i]['paymentavailable'] = 0; 
	          $resultList[$i]['operatinghours'] = $machine[8];
	          $resultList[$i]['locationdescription'] = $machine[9];
	          $resultList[$i]['paymentpointdescr'] = $machine[10];
	          $resultList[$i]['partnerid'] = $machine[11];
	          $resultList[$i]['paymenttype'] = $machine[12];
	          $i++;          
	        }
	        usort($resultList, array('Paczkomaty247API', 'machine_sort'));    
	        return $resultList;
	      }      
	    }
	  }
	  return 0;

	}


	public function cache_is_valid($cache, $config) {

	  if ($cache) {
	    $cachedTimestamp = @file_get_contents(dirname(__FILE__) . "/data/time$cache.dat");
	    if ($lastModifiedContents = @file_get_contents("$config->apiURL/?do=getparams")) {
	      $parsedXML = $this->xml2array($lastModifiedContents);
	      $lastModifiedTimestamp = $parsedXML['paczkomaty']['last_update']['value'];
	      if ($lastModifiedTimestamp>$cachedTimestamp) return 0;
	      return 1;
	    }
	  }
	  return -1;

	}


	public function download_machines($config) {

	  if ($machinesContents = @file_get_contents("$config->apiURL/?do=listmachines_csv")) {    
	    $machinesArray = split("\n",$machinesContents);
	    $machinesChecksum = $machinesArray[0];
	    $machinesContents = substr($machinesContents,strlen($machinesChecksum)+1);
	    if ($machinesChecksum != $this->crc16($machinesContents)) return 0;
	    if (count($machinesArray)) {
	      array_shift($machinesArray);
	      foreach ($machinesArray as $machine) {
	        $machine = split(";",$machine);
	        $data[] = $machine;
	      }
	      if (($cacheHandle = @fopen(dirname(__FILE__) . "/data/cache1.dat", "wb")) &&
	           ($timeHandle = @fopen(dirname(__FILE__) . "/data/time1.dat", "w"))) {
	        fwrite($cacheHandle,serialize($data));
	        fclose($cacheHandle);
	        fwrite($timeHandle,time());
	        fclose($timeHandle);
	        return 1;
	      }
	    }
	  }
	  return 0;

	}


	public function crc16($data) {

	  $crc = 0xFFFF;
	  for ($i = 0; $i < strlen($data); $i++) {
	    $x = (($crc >> 8) ^ ord($data[$i])) & 0xFF;
	    $x ^= $x >> 4;
	    $crc = (($crc << 8) ^ ($x << 12) ^ ($x << 5) ^ $x) & 0xFFFF;
	  }
	  return $crc;

	}

	public static function machine_sort($m1, $m2) {
  
		return strcmp($m1["name"], $m2["name"]);

	}
	
	function find_customer($email, $config) {
		
		if ($customerContents = @file_get_contents("$config->apiURL/?do=findcustomer&email=$email")) {     
			$parsedXML = $this->xml2array($customerContents); 
	          
		if (isset($parsedXML['paczkomaty']['error'])) {
			return array('error' => array('key' => $parsedXML['paczkomaty']['error']['attr']['key'], 'message' => $parsedXML['paczkomaty']['error']['value']));
		}
		
		$parsedXML = $parsedXML['paczkomaty']['customer'];  
		
		if ($parsedXML['email']['value']==$email) {
			$preferedBoxMachineName= $parsedXML['preferedBoxMachineName']['value'];
				if (isset($parsedXML['alternativeBoxMachineName']['value'])) $alternativeBoxMachineName= $parsedXML['alternativeBoxMachineName']['value'];  else  $alternativeBoxMachineName='';
				return array('preferedBoxMachineName' => $preferedBoxMachineName, 'alternativeBoxMachineName'=> $alternativeBoxMachineName);
			}
		}
		
		return 0;
	}
	
	public function machine_info($id_box, $config)
	{
		$machines_all = $this->get_machine_list($config); 
		$machines_with_names_as_keys=array(); 
		foreach ($machines_all as $id => $machine) $machines=$machines_with_names_as_keys[$machine['name']]=$machine;
				
		if(array_key_exists($id_box, $machines_with_names_as_keys))
			return $machines_with_names_as_keys[$id_box];
		
		return 0;
		
	}
	
	public function machines_dropdown($postcode, $email, $config, $class = NULL, $name = "paczkomaty247_box")
	{
		
		$found_box = false;
		
		$machines_all = $this->get_machine_list($config); 
		$machines_with_names_as_keys=array(); 
		foreach ($machines_all as $id => $machine) $machines=$machines_with_names_as_keys[$machine['name']]=$machine;
		
		$client = $this->find_customer($email, $config);
		
		$result= "";
		$result.= "<select id=\"".$name."\" name=\"".$name."\"";
	   	if (isset($param['class'])) $result.= " class=\"".$param['class']."\"";
   		if (isset($param['name'])) $result.= " name=\"".$param['name']."\"";
   		$result.= ">";
   		
   		//Preffered boxes
   		if($client)
   		{
   			if(!array_key_exists('error', $client))
   			{
	   			if ($client['preferedBoxMachineName'] && array_key_exists($client['preferedBoxMachineName'], $machines_with_names_as_keys)) {
	   				$result.="<option disabled>".$this->l('Paczkomat domyślny')."</option>";
	     			$result.="<option value=\"".$client['preferedBoxMachineName']."\"";
					$result.=">".$machines_with_names_as_keys[$client['preferedBoxMachineName']]['name']." ".$machines_with_names_as_keys[$client['preferedBoxMachineName']]['street']." ".$machines_with_names_as_keys[$client['preferedBoxMachineName']]['buildingnumber'].", ".$machines_with_names_as_keys[$client['preferedBoxMachineName']]['postcode']." ".$machines_with_names_as_keys[$client['preferedBoxMachineName']]['town']."</option>";
	   			}
	   			
	   			if ($client['alternativeBoxMachineName'] && array_key_exists($client['alternativeBoxMachineName'], $machines_with_names_as_keys)) {
	   				$result.="<option disabled>".$this->l('Paczkomat alternatywny')."</option>";
					$result.="<option value=\"".$client['alternativeBoxMachineName']."\"";
					$result.=">".$machines_with_names_as_keys[$client['alternativeBoxMachineName']]['name']." ".$machines_with_names_as_keys[$client['alternativeBoxMachineName']]['street']." ".$machines_with_names_as_keys[$client['alternativeBoxMachineName']]['buildingnumber'].", ".$machines_with_names_as_keys[$client['alternativeBoxMachineName']]['postcode']." ".$machines_with_names_as_keys[$client['alternativeBoxMachineName']]['town']."</option>";
	   			}
	   			
	   			$found_box = true;
   			}
   		}

   		$machines = $this->find_nearest_machines($postcode, $config);
   		if (count($machines)) {
   			$result.="<option disabled>".$this->l('Paczkomaty najbliżej kodu').": ".$postcode."</option>";
   			foreach ($machines as $machine) {
   				$result.="<option value=\"".$machine['name']."\"";
   				$result.=">".$machine['name']." ".$machine['street']." ".$machine['buildingnumber'].", ".$machine['postcode']." ".$machine['town']."</option>";
   			}		
   			$found_box = true;
   		}
   		
   		if (count($machines_all)) {
   			$result.="<option disabled>".$this->l('Wszytkie paczkomaty')."</option>";
     		foreach ($machines_all as $machine) {
     			$result.="<option value=\"".$machine['name']."\"";
     			$result.=">".$machine['name']." ".$machine['street']." ".$machine['buildingnumber'].", ".$machine['postcode']." ".$machine['town']."</option>";
   			}
   		}
   			
		$result.= "</select>";
   
		if($found_box)
			return $result;
		
		return false;
		
	}
	
	public function get_packs_by_sender($email, $password, $config, $parameters=array()) {

	  $inpost_api_url = str_replace('http://','https://',$config->apiURL);   
	  $digest = $this->inpost_digest($password);  
	  $paramData= array('email' => $email, 'digest' => $digest);
	  
	  if (isset($parameters['status'])) $paramData['status'] = $parameters['status'];
	  if (isset($parameters['startdate'])) $paramData['startdate'] = $parameters['startdate'];
	  if (isset($parameters['enddate'])) $paramData['enddate'] = $parameters['enddate'];
	  if (isset($parameters['is_conf_printed'])) $paramData['is_conf_printed'] = $parameters['is_conf_printed'];
	    
	  $postData = http_build_query($paramData);     
	  if ($packsResponse = $this->post_request("$inpost_api_url/?do=getpacksbysender",$postData)) {              
	    $parsedXML = $this->xml2array($packsResponse);
	
	    if(!$parsedXML)
	    	return 0;
	    
	    if(isset($parsedXML['paczkomaty']['pack']))
	    {
	    
	    	$packsData = $parsedXML['paczkomaty']['pack'];    
	    	if (!isset($packsData[0])) {
	      		$temp=$packsData;
	      		$packsData=array();
	      		$packsData[0]=$temp;
	    	}
	    	       
	    	if (count($packsData)) {      
	      		$i = 0;
	      		foreach ($packsData as $packData) {
	        		foreach ($packData as $param => $value) {          
	          		if (isset($value['value']))  $resultData[$i][$param] = $value['value']; else $resultData[$i][$param] = '';  
	        		}
	        		$i++;
	      		}
	      		return $resultData;
	    	}
	  }elseif(isset($parsedXML['paczkomaty']['error']))
	  		return $parsedXML['paczkomaty'];
	  
	  }
	  return 0;
  
	}
	
	public function inpost_digest($string)
	{
	  $version=phpversion();
	  if ($version[0]<5)
	  $digest = base64_encode(pack('H*', md5($string)));
	  else
	  $digest = base64_encode(md5($string,true));  
	  
	  return $digest;
	}
	
	public function post_request($url, $data)
	{
	     $params = array('http' => array(
	                  'method' => 'POST',
	                  'header' => "Content-type: application/x-www-form-urlencoded\r\n"
	                . "Content-Length: " . strlen($data) . "\r\n",
	                  'content' => $data
	               ));
	     
	     $ctx = stream_context_create($params);
	     $fp = @fopen($url, 'rb', false, $ctx);     
	     if (!$fp) {        
	        return 0;
	     }
	     
	     $response = '';
	     while (!feof($fp)) {
	     $response .= fread($fp, 8192);
	     }
	
	     //$response = stream_get_contents($fp);
	     if ($response === false || $response=='') {
	        return 0;
	     }
	     return $response;
	}
	
	function send_packs($config, $packsData) {
		  
		  $inpost_api_url = str_replace('http://','https://',$config->apiURL); 
		  
		  $digest = $this->inpost_digest($config->apiPw);
		  
		  if (count($packsData)) {
		  
		    $packsXML =  "<paczkomaty>\n";
		    $packsXML .= "<autoLabels>".$config->apiautolabels."</autoLabels>\n"; 
		    $packsXML .= "<selfSend>".$config->apiselfsend."</selfSend>\n"; 
		    foreach ($packsData as $packId => $packData) {
		      $packsXML .= "<pack>\n";
		      $packsXML .= "<id>".$packId."</id>\n";
		      $packsXML .= "<adreseeEmail>".$packData['adreseeEmail']."</adreseeEmail>\n";
		      $packsXML .= "<senderEmail>".$packData['senderEmail']."</senderEmail>\n";
		      $packsXML .= "<phoneNum>".$packData['phoneNum']."</phoneNum>\n";
		      $packsXML .= "<boxMachineName>".$packData['boxMachineName']."</boxMachineName>\n";
		      $packsXML .= "<alternativeBoxMachineName>".$packData['alternativeBoxMachineName']."</alternativeBoxMachineName>\n";
		      $packsXML .= "<packType>".$packData['packType']."</packType>\n";
		      $packsXML .= "<insuranceAmount>".$packData['insuranceAmount']."</insuranceAmount>\n";
		      $packsXML .= "<onDeliveryAmount>".$packData['onDeliveryAmount']."</onDeliveryAmount>\n";
		      $packsXML .= "<customerRef>".$packData['customerRef']."</customerRef>\n";
		      $packsXML .= "</pack>\n";      
		    }
		    $packsXML .= "</paczkomaty>\n";
		    
		    $packsData = array ('email' => $config->apiLogin, 'digest' => $digest, 'content' => $packsXML);
		
		    $_lastArgSeparatorOutput = ini_get('arg_separator.output'); 
		    ini_set('arg_separator.output', '&'); 
		    $postData = http_build_query($packsData);
		    
		    if ($packsResponse = $this->post_request("$inpost_api_url/?do=createdeliverypacks",$postData)) {
		    	$parsedXML = $this->xml2array($packsResponse);
		    	
		    	if (isset($parsedXML['paczkomaty']['error'])) {
		    			return array('error' => array('key' => $parsedXML['paczkomaty']['error']['attr']['key'], 'message' => $parsedXML['paczkomaty']['error']['value']));
				}
		      
				if (isset($parsedXML['paczkomaty']['pack'])) $packsData = $parsedXML['paczkomaty']['pack'];
				if (!isset($packsData[0])) {
					$temp=$packsData;
					$packsData=array();
					$packsData[0]=$temp;
				}       
				if (count($packsData)) {
					foreach ($packsData as $packData) {
						if (isset($packData['packcode']['value'])) $resultData[$packData['id']['value']]['packcode'] = $packData['packcode']['value'];
						if (isset($packData['customerdeliveringcode']['value'])) $resultData[$packData['id']['value']]['customerdeliveringcode'] = $packData['customerdeliveringcode']['value'];
						if (isset($packData['error']['attr']['key'])) $resultData[$packData['id']['value']]['error_key'] = $packData['error']['attr']['key'];
						if (isset($packData['error']['value'])) $resultData[$packData['id']['value']]['error_message'] = $packData['error']['value'];
		        	}
					if (isset($resultData)) return $resultData; else return array();
				}
		    }
		    ini_set('arg_separator.output', $_lastArgSeparatorOutput);    
		  }
		  return 0;
	  
	}
	
	function get_sticker($config, $packCode) {
	  
		$inpost_api_url = str_replace('http://','https://',$config->apiURL);  
	  
		$digest = $this->inpost_digest($config->apiPw);
	      
		if ($packCode) {
			$customerData = array ('email' => $config->apiLogin, 'digest' => $digest, 'packcode' => $packCode);
			$postData = http_build_query($customerData);    
			if ($customerResponse = $this->post_request("$inpost_api_url/?do=getsticker",$postData)) {
				if (strpos($customerResponse,'PDF')) return $customerResponse;                               
				$parsedXML = $this->xml2array($customerResponse);      
				if (isset($parsedXML['paczkomaty']['error'])) {
					return array('error' => array('key' => $parsedXML['paczkomaty']['error']['attr']['key'], 'message' => $parsedXML['paczkomaty']['error']['value']));
				}
			}

		}  
		return 0;
	}
	
	function get_confirm_printout($config, $packCode, $testPrintout=0) {
	  
		$inpost_api_url = str_replace('http://','https://',$config->apiURL);  
		$digest = $this->inpost_digest($config->apiPw);  
		
		$packsXML =  "<paczkomaty>\n";
		$packsXML .= "<testprintout>$testPrintout</testprintout>\n"; 
		$packsXML .= "<pack>\n";
		$packsXML .= "<packcode>".$packCode."</packcode>\n";
		$packsXML .= "</pack>\n";      	
		$packsXML .= "</paczkomaty>\n";
	
		$packsData = array ('email' => $config->apiLogin, 'digest' => $digest, 'content' => $packsXML);    
	  
		$_lastArgSeparatorOutput = ini_get('arg_separator.output'); 
		ini_set('arg_separator.output', '&'); 
		$postData = http_build_query($packsData);
			
		if ($customerResponse = $this->post_request("$inpost_api_url/?do=getconfirmprintout",$postData)) {
			if (strpos($customerResponse,'PDF')) return $customerResponse;                               
			$parsedXML = $this->xml2array($customerResponse);      
			if ($parsedXML['paczkomaty']['error']) {
				ini_set('arg_separator.output', $_lastArgSeparatorOutput);
					return array('error' => array('key' => $parsedXML['paczkomaty']['error']['attr']['key'], 'message' => $parsedXML['paczkomaty']['error']['value']));
			}
		}
		return 0;
	}
	
}