<?php

class Paczkomaty247CarrierUtils
{
	
	public static function getPaczkomaty247Carriers($config)
	{
		global $cookie;
		
		//Get zone from address !!!
		$id_zone = 1;
		$ids_group = NULL;
	
		$allCarriers = Paczkomaty247CarrierUtils::getCarriers(intval($cookie->id_lang), true, false, $id_zone, $ids_group, true);
                $electedCarrier = NULL;
		
		foreach ($allCarriers as $carrier) {
			if ($carrier['name'] == 'paczkomaty247')
			{
				$mCarrier = new Paczkomaty247Carrier($carrier['id_carrier']);
				$mCarrier->setDeliveryPrice(floatval($config->price)); //TODO vat
				
				$electedCarrier = $mCarrier;
			}
		}	

		return $electedCarrier;
	}

	public static function getCarriers($id_lang, $active = false, $delete = false, $id_zone = false, array $ids_group = NULL, $all = false)
    {
		if (!Validate::isBool($active))
			die(Tools::displayError());
			
		if ($ids_group)
			{
				$ids = '';
				foreach ($ids_group as $id)
					$ids .= intval($id).', ';
					$ids = rtrim($ids, ', ');
					if ($ids == '')
						return (array());
					}
			$sql = '
				SELECT c.*, cl.delay
				FROM `'._DB_PREFIX_.'carrier` c
				LEFT JOIN `'._DB_PREFIX_.'carrier_lang` cl ON (c.`id_carrier` = cl.`id_carrier` AND cl.`id_lang` = '.intval($id_lang).')
				LEFT JOIN `'._DB_PREFIX_.'carrier_zone` cz  ON (cz.`id_carrier` = c.`id_carrier`)'.
				($id_zone ? 'LEFT JOIN `'._DB_PREFIX_.'zone` z  ON (z.`id_zone` = '.intval($id_zone).')' : '').'
				WHERE c.`deleted` '.($delete ? '= 1' : ' = 0').
				($active ? ' AND c.`active` = 1' : '').
				($id_zone ? ' AND cz.`id_zone` = '.intval($id_zone).'
				AND z.`active` = 1' : '').'
				'.($all ? NULL : 'AND c.`is_module` = 0').'
				'.($ids_group ? 'AND c.id_carrier IN (SELECT id_carrier FROM '._DB_PREFIX_.'carrier_group WHERE id_group IN ('.$ids.')) ' : '').'
				GROUP BY c.`id_carrier`';
				
			$carriers = Db::getInstance()->ExecuteS($sql);
			if (is_array($carriers) AND count($carriers))
			{
				foreach ($carriers as $key => $carrier)
					if ($carrier['name'] == '0')
						$carriers[$key]['name'] = Configuration::get('PS_SHOP_NAME');
					}
			else
				$carriers = array();

			return $carriers;
	}

	public static function carrierExists($config)
	{
		global $cookie;
                $id_zone = 1;

		$moduleCountryIsoCode = strtoupper($config->country);
		$countryID = Country::getByIso($moduleCountryIsoCode);
		if (intval($countryID))
                	$id_zone = Country::getIdZone($countryID);
		
		$allCarriers = Paczkomaty247CarrierUtils::getCarriers(intval($cookie->id_lang), true, false, $id_zone, NULL, true);

		foreach ($allCarriers as $carrier) {
                        if (($carrier['name'] == 'paczkomaty247') && ($carrier['is_module'] == true)) return true ;
                }
                return false;
	}

	public static function createPaczkomaty247Carrier($config)
	{
		$id_zone = 1;
		$moduleCountryIsoCode = strtoupper($config->country);
		$countryID = Country::getByIso($moduleCountryIsoCode);
                if (intval($countryID))
                        $id_zone = Country::getIdZone($countryID);
                
		$vatRate = floatval($config->tax);	
		$id_tax = Tax::getTaxIdByRate($vatRate);
		if (!$id_tax)
                {
                        $tax = new Tax();
                        $tax->rate = $vatRate;
                        $defaultLanguage = Configuration::get('PS_LANG_DEFAULT');
                        $tax->name[$defaultLanguage] = $tax->rate . '%';
                        $tax->add();
                        $id_tax = Tax::getTaxIdByRate($vatRate);
                }
		if (!Tax::zoneHasTax($id_tax, $id_zone))
		{
			Db::getInstance()->Execute('INSERT INTO `'._DB_PREFIX_.'tax_zone` (`id_tax` , `id_zone`) VALUES ('.intval($id_tax).', '.intval($id_zone).')');
		}
	
		$carrier = new Carrier();
                $carrier->name = 'paczkomaty247';
                $carrier->id_tax = $id_tax;
                $carrier->url = _PS_BASE_URL_.'/modules/paczkomaty247/tracking.php?n=@';
                $carrier->active = true;
                $carrier->deleted = 0;
                $carrier->shipping_handling = false;
                $carrier->range_behavior = 0;
                $carrier->is_module = 1;
		$languages = Language::getLanguages(true);
		foreach ($languages as $language) {
			if ($language['iso_code'] == 'en')
				$carrier->delay[$language['id_lang']] = utf8_encode('2 days');
			if ($language['iso_code'] == 'pl')
				$carrier->delay[$language['id_lang']] = utf8_encode('2 dni robocze');
		}
		$carrier->add();

		$sql = 'INSERT INTO `'._DB_PREFIX_.'carrier_zone` (`id_carrier` , `id_zone`) VALUES ('.intval($carrier->id).', ' . intval($id_zone) . ')';
		Db::getInstance()->Execute($sql);

		$rangeW = new RangeWeight();
                $rangeW->id_carrier = $carrier->id;
                $rangeW->delimiter1 = 0;
                $rangeW->delimiter2 = 12; 
                $rangeW->add();
		
		$vat_factor = (1+ ($config->tax / 100));
		$priceTTC = round((floatval($config->price)*$vat_factor), 2);
		$priceHT = round($priceTTC/$vat_factor, 2);
		$priceList = '(NULL'.','.$rangeW->id.','.$carrier->id.','.$id_zone.','.$priceHT.')';
		$carrier->addDeliveryPrice($priceList);
		return (new Carrier($carrier->id));
	}
}