<?php

class Paczkomaty247Config
{
	public $country = "pl";
	public $installed = 1;
	public $apiURL = "http://api.paczkomaty.pl";
	public $tax = "22.00";
	public $price = "5.73";
	public $apiLogin = NULL;
	public $apiPw = NULL;
	public $apiEnable = false;
	public $trigerringStatuses = '2,4';
	public $apiautolabels = 1;
	public $apiselfsend = 0;
	public $apipacktype = "A";
	
		
	public function saveConfig()
	{
		if ( Configuration::updateValue('P247_API_URL', $this->apiURL) == false
		OR Configuration::updateValue('P247_COUNTRY', $this->country) == false
		OR Configuration::updateValue('P247_INSTALLED', $this->installed) == false
		OR Configuration::updateValue('P247_TAX', $this->tax) == false
		OR Configuration::updateValue('P247_PRICE', $this->price) == false
		OR Configuration::updateValue('P247_API_LOGIN', $this->apiLogin) == false
		OR Configuration::updateValue('P247_API_PW', $this->apiPw) == false
		OR Configuration::updateValue('P247_API_ENABLE', $this->apiEnable) == false
		OR Configuration::updateValue('P247_TRIGERRING_STATUSES', $this->trigerringStatuses) == false
		OR Configuration::updateValue('P247_API_AUTO_LABELS', $this->apiautolabels) == false
		OR Configuration::updateValue('P247_API_SELF_SEND', $this->apiselfsend) == false
		OR Configuration::updateValue('P247_API_PACK_TYPE', $this->apipacktype) == false
		) {
			 return (false);
		}
		
		return (true);
	}

	public function uninstall()
	{
		Configuration::deleteByName('P247_API_URL');
		Configuration::deleteByName('P247_COUNTRY');
		Configuration::deleteByName('P247_INSTALLED');
		Configuration::deleteByName('P247_TAX');
		Configuration::deleteByName('P247_API_LOGIN');
		Configuration::deleteByName('P247_API_PW');
		Configuration::deleteByName('P247_API_ENABLE');
		Configuration::deleteByName('P247_TRIGERRING_STATUSES');
		Configuration::deleteByName('P247_API_AUTO_LABELS');
		Configuration::deleteByName('P247_API_SELF_SEND');
		Configuration::deleteByName('P247_API_PACK_TYPE');
		
	}

	public function loadConfig()
	{
		$this->installed = html_entity_decode(Configuration::get('P247_INSTALLED'), ENT_COMPAT, 'UTF-8');
		$this->country = html_entity_decode(Configuration::get('P247_COUNTRY'), ENT_COMPAT, 'UTF-8');
		if (strlen($this->country) == 0)
			$this->country = 'pl';

		$this->apiURL = html_entity_decode(Configuration::get('P247_API_URL'), ENT_COMPAT, 'UTF-8');
		$this->tax = html_entity_decode(Configuration::get('P247_TAX'), ENT_COMPAT, 'UTF-8');
		$this->price = html_entity_decode(Configuration::get('P247_PRICE'), ENT_COMPAT, 'UTF-8');
		
		$this->apiLogin = html_entity_decode(Configuration::get('P247_API_LOGIN'), ENT_COMPAT, 'UTF-8');
		$this->apiPw = html_entity_decode(Configuration::get('P247_API_PW'), ENT_COMPAT, 'UTF-8');
		$this->apiEnable = html_entity_decode(Configuration::get('P247_API_ENABLE'), ENT_COMPAT, 'UTF-8');
		$this->trigerringStatuses = html_entity_decode(Configuration::get('P247_TRIGERRING_STATUSES'), ENT_COMPAT, 'UTF-8');
		
		$this->apiautolabels = html_entity_decode(Configuration::get('P247_API_AUTO_LABELS'), ENT_COMPAT, 'UTF-8');
		$this->apiselfsend = html_entity_decode(Configuration::get('P247_API_SELF_SEND'), ENT_COMPAT, 'UTF-8');
		$this->apipacktype = html_entity_decode(Configuration::get('P247_API_PACK_TYPE'), ENT_COMPAT, 'UTF-8');
	}
	
	public function get($param)
	{
		return $this->$param;
		
	}
}